#ifndef __INTERFACE_TO_AES_H
#define __INTERFACE_TO_AES_H

#include "AES/AES.h"
#include <string.h>

AES EncryptAes;
AES DecryptAes;
char En_inited=0;
char Dec_inited=0;
char tables_created=0;

unsigned long encrypt_init(char *key, unsigned long key_size) {
	if (!En_inited) {
		if (!tables_created) {
			CreateAESTables(true);
			tables_created=1;
		}
		EncryptAes.SetParameters(key_size*8,key_size*8);
		EncryptAes.StartEncryption((unsigned char *)key);
		En_inited=1;
		return 1;
	}
	return 0;
}

unsigned long decrypt_init(char *key, unsigned long key_size) {
	if (!Dec_inited) {
		if (!tables_created) {
			CreateAESTables(true);
			tables_created=1;
		}
		DecryptAes.SetParameters(key_size*8,key_size*8);
		DecryptAes.StartDecryption((unsigned char *)key);
		Dec_inited=1;
		return 1;
	}
	return 0;
}

unsigned long decrypt(char *in_buffer, long in_buffer_size, char *out_buffer, unsigned long out_buffer_size, char ignore_size=0) {
    int size=0;
    if (ignore_size)
        size=in_buffer_size;
    else {
	    if (*in_buffer!='x') {
		    return 0;
	    }
        in_buffer++;
        size=*(long *)in_buffer;
	    in_buffer+=sizeof(long);
        in_buffer_size-=5;
    }
	while (in_buffer_size>=16) {
		DecryptAes.Decrypt((unsigned long *)in_buffer, (unsigned long *)out_buffer);
		in_buffer+=16;
		out_buffer+=16;
		in_buffer_size-=16;
	}
	return size;	
}

unsigned long encrypt(char *in_buffer, long in_buffer_size, char *out_buffer, unsigned long out_buffer_size) {
	*out_buffer='x';
	out_buffer++;
	*(long *)out_buffer=in_buffer_size;
	out_buffer+=sizeof(long);

    char last_buf[16];
    long in_buffer2_size=in_buffer_size;
    long padding=0;
    if (in_buffer_size%16) {
        in_buffer2_size=(in_buffer_size/16+1)*16;
        padding=16-(in_buffer2_size-in_buffer_size);
    }

	int size=5;
	while (in_buffer2_size>0) {
        if ((in_buffer2_size==16) && (padding)) {
            memcpy(last_buf, in_buffer, padding);
		    EncryptAes.Encrypt((unsigned long *)last_buf, (unsigned long *)out_buffer);
        } else
		    EncryptAes.Encrypt((unsigned long *)in_buffer, (unsigned long *)out_buffer);

		in_buffer2_size-=16;
        size+=16;
		in_buffer+=16;
		out_buffer+=16;
	}
	return size;
}

#endif //__INTERFACE_TO_AES_H
