#include "messages.h"
#include "BasicMessages.h"
#include "ConceptClient.h"
#include "httpmessaging.h"
#include <time.h>

#include "INTERFACE_TO_AES.h"

AnsiList  BufferedMessages;

#ifdef _WIN32
    #include <winsock.h>
#else
    #include <sys/types.h>
    #include <sys/socket.h>
    #include <netinet/in.h>
#endif


#define LESS_CHECKS_FOR_SPEED

static FILE *PostFile=0;
//-----------------------------------------------------------------------------------
void set_next_post_filename(char *filename) {
    if (PostFile)
        fclose(PostFile);
    PostFile=fopen(filename, "wb");
}
//-----------------------------------------------------------------------------------
inline int post_write(char *buf, int len) {
    if (!PostFile)
        return -1;
    return fwrite(buf, 1, len, PostFile);
}
//-----------------------------------------------------------------------------------
inline void post_done() {
    if (PostFile) {
        fclose(PostFile);
        PostFile=0;
    }
}
//-----------------------------------------------------------------------------------
#define ADJUST_SIZE(s)  size2-=s; if (size2<0) return -1;
int DeSerializeBuffer(char *buffer, long size, AnsiString *Owner, long *message, AnsiString *Target, AnsiString *Value) {
    // OWNER poate avea maxim 256 octeti
    long size2=size;
    int res=0;
    char *ptr=buffer;
    ADJUST_SIZE(1);
    unsigned char owner_size=*(unsigned char *)buffer;
    buffer++;
    long proc_size=1;
    if (owner_size) {
        ADJUST_SIZE(owner_size);
        Owner->LoadBuffer(buffer, owner_size);
        buffer+=owner_size;
        proc_size+=owner_size;
    } else
        *Owner=(char *)"";

    ADJUST_SIZE(sizeof(long));
    *message=ntohl(*(long *)buffer);
    buffer+=sizeof(long);
    proc_size+=sizeof(long);
    ADJUST_SIZE(sizeof(unsigned short));
    unsigned short target_size=ntohs(*(unsigned short *)buffer);
    buffer+=sizeof(short);
    proc_size+=sizeof(short);
    if (target_size>0) {
        ADJUST_SIZE(target_size);
        Target->LoadBuffer(buffer, target_size);
        buffer+=target_size;
        proc_size+=target_size;
    } else
        *Target=(char *)"";

    long last_size=size-proc_size;//(buffer-ptr);
    if (last_size>0) {
        Value->LoadBuffer(buffer,last_size);
        res=proc_size;
    } else  
        *Value=(char *)"";
    return res;
}
//-----------------------------------------------------------------------------------
char *SerializeBuffer(char **buffer, long *size, AnsiString *Owner, long message, AnsiString *Target, AnsiString *Value, bool buferize, FILE **file_buffer, long *fsize) {
    // OWNER poate avea maxim 256 octeti
    long vsize=Value->Length();
    *fsize=0;
    FILE *in=NULL;
    *file_buffer=NULL;
    if ((message==MSG_REQUEST_FOR_FILE) && (vsize)) {
        vsize=0;
        in=fopen(Value->c_str(),"rb");
        if (in) {
            fseek(in,0,SEEK_END);
            if (buferize)
                vsize=ftell(in);
            else
                *fsize=ftell(in);
            fseek(in,0,SEEK_SET);
        }    
    }

    *size=sizeof(char)+Owner->Length()+sizeof(long)+sizeof(short)+Target->Length()+vsize;
    char *ptr=new char[*size+sizeof(long)];
    // add the file buffer, if we have one
    *(long *)ptr=htonl(*size+*fsize);
    char *buf=ptr+sizeof(long);//new char[*size];
    *buffer=buf;

    /*char *ptr=new char[*size];
    char *buf=ptr;
    *buffer=buf;*/

    *(unsigned char *)buf=(unsigned char)Owner->Length();
    buf+=sizeof(char);

    memcpy(buf, Owner->c_str(), Owner->Length());
    buf+=Owner->Length();

    *(long *)buf=htonl(message);
    buf+=sizeof(long);

    *(unsigned short *)buf=htons((unsigned short)Target->Length());
    buf+=sizeof(short);

    memcpy(buf, Target->c_str(), Target->Length());
    buf+=Target->Length();

    if (in) {
        if (buferize) {
            int r=0;
            do {
                r=fread(buf,1,RBUF_SIZE,in);
                if (r>0)
                    buf+=r;
            } while (r==RBUF_SIZE);
            fclose(in);
        } else
            *file_buffer=in;
    } else
        memcpy(buf, Value->c_str(), Value->Length());
    return ptr;
}
//-----------------------------------------------------------------------------------
unsigned long AES_encrypt(char *in_buffer, unsigned long in_buffer_size, char *out_buffer, unsigned long out_buffer_size, char *key, unsigned long key_size) {
	if (!En_inited)
		encrypt_init(key,key_size);

	return encrypt(in_buffer,in_buffer_size,out_buffer,out_buffer_size);
}
//-----------------------------------------------------------------------------------
unsigned long AES_decrypt(char *in_buffer, unsigned long in_buffer_size, char *out_buffer, unsigned long out_buffer_size, char *key, unsigned long key_size, char ignore_size=0) {
	if (!Dec_inited)
		decrypt_init(key,key_size);

	return decrypt(in_buffer,in_buffer_size,out_buffer,out_buffer_size,ignore_size);
}
//-----------------------------------------------------------------------------------

int send_message(AnsiString SENDER_NAME, long MESSAGE_ID,  AnsiString MESSAGE_TARGET, AnsiString MESSAGE_DATA, SOCKET CLIENT_SOCKET, char *REMOTE_PUBLIC_KEY, PROGRESS_API notify_parent, bool idle_call) {
	    INTEGER res=0;
        char *buffer=0;
        long in_content_size=0;
        FILE *in=0;
        long file_buffer_size=0;
        bool buferize=REMOTE_PUBLIC_KEY ? true : false;
        char *base_ptr=SerializeBuffer(&buffer, &in_content_size, &SENDER_NAME, MESSAGE_ID, &MESSAGE_TARGET, &MESSAGE_DATA, buferize, &in, &file_buffer_size);
        long size_n;

        if ((REMOTE_PUBLIC_KEY) && (!CConceptClient::is_http)) {
            // criptez query-ul ...
            int out_content_size=(in_content_size/16+1)*16+5;//(((in_content_size / 48) + 1) * 64) + 256;
            char *out_content=new char[out_content_size];

            int encrypt_result = AES_encrypt(   buffer, in_content_size,
                                                out_content, out_content_size,
                                                REMOTE_PUBLIC_KEY, /*strlen(REMOTE_PUBLIC_KEY)*/16 );
            if (!encrypt_result) {
                    delete[] out_content;
                    return 0;
            }

            long size=encrypt_result;
            size_n=htonl(size);

            send(CLIENT_SOCKET,(char *)&size_n, sizeof(long), 0);

            //----------------------------------------//
            if ((size >= BIG_MESSAGE) && (notify_parent)) {
                // notify big message !
                notify_parent(-1,"Sending data",idle_call);
                int chunks=size/CHUNK_SIZE;
                if (size%CHUNK_SIZE)
                    chunks++;
                for (int i=0;i<chunks;i++) {
                    int chunk_size=(i<chunks-1) ? CHUNK_SIZE : size%CHUNK_SIZE;
                    res=send(CLIENT_SOCKET,out_content+(i*CHUNK_SIZE), chunk_size, 0);
                    if (res!=chunk_size) {
                        notify_parent(-1,"Error in sending data",idle_call);
                        break;
                    }
                    notify_parent((int)(((double)(i*CHUNK_SIZE+res)/size)*100),0,idle_call);
                }
                notify_parent(101,0,idle_call);
                // done big message !
            } else
                res=send(CLIENT_SOCKET,out_content, size, 0);
            delete[] out_content;
        } else {

            // trimit dimensiunea mai intai ...
            size_n=htonl(in_content_size+file_buffer_size);
            if (!CConceptClient::is_http)
                send(CLIENT_SOCKET,(char *)&size_n, sizeof(long), 0);
            bool big_message=false;
            int total_sent=0;
            if ((in_content_size+file_buffer_size >= BIG_MESSAGE) && (notify_parent)) {
                // notify big message !
                big_message=true;
                notify_parent(-1,"Sending data",idle_call);
                int chunks=in_content_size/CHUNK_SIZE;
                if (in_content_size%CHUNK_SIZE)
                    chunks++;
                for (int i=0;i<chunks;i++) {
                    int chunk_size=(i<chunks-1) ? CHUNK_SIZE : in_content_size%CHUNK_SIZE;
                    int to_send=chunk_size;
                    if (CConceptClient::is_http) {
                        if (i) {
                            res=HTTPPostSend(CConceptClient::HTTP_SendLink, buffer+(i*CHUNK_SIZE), chunk_size, chunk_size);
                        } else {
                            to_send=chunk_size+sizeof(long);
                            // add the 4 octets size
                            res=HTTPPostSend(CConceptClient::HTTP_SendLink, base_ptr, to_send, to_send);
                        }
                    } else
                        res=send(CLIENT_SOCKET,buffer+(i*CHUNK_SIZE), chunk_size, 0);
                    if (res!=to_send) {
                        notify_parent(-1,"Error in sending data",idle_call);
#ifdef _WIN32
                        Sleep(1000);
#else
                        sleep(1);
#endif
                        if (in) {
                            fclose(in);
                            in=0;
                        }
                        break;
                    }
                    total_sent=i*CHUNK_SIZE+res;
                    notify_parent((int)(((double)(total_sent)/(in_content_size+file_buffer_size))*100),0,idle_call);
                }
                if (!in)
                    notify_parent(101,0,idle_call);
                // done big message !
            } else {
                if (CConceptClient::is_http)
                    res=HTTPPostSend(CConceptClient::HTTP_SendLink, base_ptr, in_content_size+sizeof(long), 0xFFFFFF, notify_parent);
                else
                    res=send(CLIENT_SOCKET,buffer, in_content_size, 0);
            }

            if (in) {
                int r=0;
                char *file_buf=new char[RBUF_SIZE];
                int chunk_size=0;
                do {
                    chunk_size=fread(file_buf,1,RBUF_SIZE,in);
                    if (chunk_size>0) {
                        if (CConceptClient::is_http)
                            res=HTTPPostSend(CConceptClient::HTTP_SendLink, file_buf, chunk_size, chunk_size);
                        else
                            res=send(CLIENT_SOCKET, file_buf, chunk_size, 0);
                        if (res!=chunk_size) {
                            if (big_message)
                                notify_parent(-1,"Error in sending data",idle_call);
                            break;
                        }
                        total_sent+=res;
                        if (big_message)
                            notify_parent((int)(((double)(total_sent)/(in_content_size+file_buffer_size))*100),0,idle_call);
                    }
                } while (chunk_size==RBUF_SIZE);
                delete[] file_buf;
                fclose(in);
                in=NULL;
                if (big_message)
                    notify_parent(101,0,idle_call);
            }
        }
		if (base_ptr)
			delete[] base_ptr;
		// BUG: buffer=base_ptr+sizeof(long). Cannot delete buffer !
        //delete[] buffer;
        return 0;
}
//---------------------------------------------------------------------------
int AES_recv_exact(SOCKET CLIENT_SOCKET, char *buffer, int remaining, int flags, char *LOCAL_PRIVATE_KEY) {
    int size=remaining;
    remaining=(remaining/16)*16;
    int total=0;
    int rec=0;
    do {
        rec=recv(CLIENT_SOCKET,buffer+total,remaining,0);
        if (rec>0) {
            total+=rec;
            remaining-=rec;
        }
    } while ((rec>0) && (remaining>0));
    if ((!remaining) && (size)) {
        char *out_content=new char[size+1];
        long decrypt_result = AES_decrypt(  buffer, size,
                                            out_content, size,
                                            LOCAL_PRIVATE_KEY, 16, 1);
        out_content[decrypt_result]=0;
        if (!decrypt_result) {
            delete[] out_content;
        } else {
            memcpy(buffer, out_content, decrypt_result);
            size=decrypt_result;
            delete[] out_content;
        }
    } else
        size=-1;

    return size;
}
int get_message(TParameters *PARAM, SOCKET CLIENT_SOCKET, char *LOCAL_PRIVATE_KEY, PROGRESS_API notify_parent, bool idle_call) {
        long size=0;
        int received=0;
        int result=0;
        int rec_count=0;
        int buf_size=0;
        char *buffer=0;
        char *output=0;
        int filemarker=0;
        long MSG_ID=0;
        long remaining=0;
        int decrypt_result=0;

		if (BufferedMessages.Count()) {
			TParameters *clone=(TParameters *)BufferedMessages.Remove(0);
			PARAM->Sender=clone->Sender;
			PARAM->ID=clone->ID;
			PARAM->Target=clone->Target;
			PARAM->Value=clone->Value;
			//PARAM->Owner=clone->Owner;
			delete clone;
			return 1;
		}

        if (CConceptClient::is_http) {
            size=0;
            do {
	            received=HTTPRecv(CConceptClient::HTTP_RecvLink,(char *)&size+rec_count,sizeof(long)-rec_count,0, notify_parent, idle_call);
                rec_count+=received;
            } while ((rec_count<sizeof(long)) && (received>0));
            size=ntohl(size);
            if (received<=0) {
                if (PostFile)
                    post_done();
                return 0;
            }
    		
            buf_size=size;
            if (size) {
                if (PostFile)
                    buf_size = size>FILE_MESSAGE ? FILE_MESSAGE : size;
               buffer=new char[buf_size+1];
            }

            //----------------------------------------//
            if ((size >= BIG_MESSAGE) && (notify_parent)) {
                // notify big message !
                notify_parent(-1,"Receiving data",idle_call);
            }
            //----------------------------------------//
            rec_count=0;
            do {
                if (PostFile) {
                    if (filemarker) {
                        remaining=size-rec_count;
                        if (remaining>buf_size)
                            remaining=buf_size;
                        received=HTTPRecv(CConceptClient::HTTP_RecvLink,buffer,remaining,0);
                    } else
                        received=HTTPRecv(CConceptClient::HTTP_RecvLink,buffer+rec_count,buf_size-rec_count,0);
                    rec_count+=received;
                    if (received>0) {
                        if (filemarker) {
                            post_write(buffer, received);
                        } else
                        if (rec_count==buf_size) {
                            PARAM->Sender=(char *)"";
                            PARAM->Target=(char *)"";
                            PARAM->Value=(char *)"";
                            int fpos=DeSerializeBuffer(buffer, buf_size, &PARAM->Sender, &MSG_ID, &PARAM->Target, &PARAM->Value);
                            PARAM->ID=MSG_ID;
                            PARAM->Value.LoadBuffer(0,0);
                            if ((fpos>0) && (fpos<buf_size))
                                post_write(buffer+fpos, buf_size-fpos);
                            filemarker=1;
                        }
                    }
                } else {
                    received=HTTPRecv(CConceptClient::HTTP_RecvLink,buffer+rec_count,size-rec_count,0);
                    rec_count+=received;
                }

                if ((size >= BIG_MESSAGE) && (notify_parent)) {
                    notify_parent((int)(((double)rec_count/size)*100),0,idle_call);
                }
            } while ((received>0) && (rec_count<size));

            if ((size >= BIG_MESSAGE) && (notify_parent)) {
                notify_parent(101,0,idle_call);
                // done big message !
            }

	        if (received<=0) {
               if (buffer)
	                delete[] buffer;
               if (PostFile)
                    post_done();
               return 0;
            }
        } else {
            do {
	            received=recv(CLIENT_SOCKET,(char *)&size+rec_count,sizeof(long)-rec_count,0);
                rec_count+=received;
            } while ((rec_count<sizeof(long)) && (received>0));
            size=ntohl(size);
            if (received<=0) {
                if (PostFile)
                    post_done();
                return 0;
            }
    		
            buf_size=size;
            char *out_content2=0;
            int initial_buf=0;

            if (size) {
                if (PostFile) {
                    buf_size = size > FILE_MESSAGE ? FILE_MESSAGE : size;
                    if (size>FILE_MESSAGE)
                        initial_buf = buf_size+5;
                    else
                        initial_buf = buf_size;
                    if (LOCAL_PRIVATE_KEY)
                       out_content2=new char[buf_size*2];
                }
                buffer=new char[buf_size+1];
            }

            //----------------------------------------//
            if ((size >= BIG_MESSAGE) && (notify_parent)) {
                // notify big message !
                notify_parent(-1,"Receiving data",idle_call);
            }
            //----------------------------------------//
            rec_count=0;
            do {
                if (PostFile) {
                    if (filemarker) {
                        remaining=size-rec_count;
                        if (remaining>buf_size)
                            remaining=buf_size;
                        if (LOCAL_PRIVATE_KEY) {
                            received=AES_recv_exact(CLIENT_SOCKET,buffer,remaining,0,LOCAL_PRIVATE_KEY);
                            std::cerr << "Received: " << received << "\n";
                        } else
                            received=recv(CLIENT_SOCKET,buffer,remaining,0);
                    } else
                        received=recv(CLIENT_SOCKET,buffer+rec_count,initial_buf-rec_count,0);
                    rec_count+=received;
                    if (received>0) {
                        if (filemarker)
                            post_write(buffer, received);
                        else
                        if (rec_count==initial_buf) {
                            PARAM->Sender=(char *)"";
                            PARAM->Target=(char *)"";
                            if (LOCAL_PRIVATE_KEY) {
                                buffer[rec_count]=0;
std::cerr << "Rec_count: " << rec_count << "\n";
                                decrypt_result = AES_decrypt(buffer, rec_count, out_content2, rec_count, LOCAL_PRIVATE_KEY, 16);
                                if (decrypt_result) {
                                    decrypt_result=rec_count-5;
                                    out_content2[decrypt_result]=0;
                                }
                            }
                            int fpos=0;
                            if (decrypt_result>0) {
                                fpos=DeSerializeBuffer(out_content2, decrypt_result, &PARAM->Sender, &MSG_ID, &PARAM->Target, &PARAM->Value);
std::cerr << "Received(1): " << decrypt_result-fpos << "\n";
                                if ((fpos>0) && (fpos<decrypt_result))
                                    post_write(out_content2+fpos, decrypt_result-fpos);
                                delete[] out_content2;
                                out_content2=0;
                            } else {
                                fpos=DeSerializeBuffer(buffer, rec_count, &PARAM->Sender, &MSG_ID, &PARAM->Target, &PARAM->Value);
                                if ((fpos>0) && (fpos<rec_count))
                                    post_write(buffer+fpos, rec_count-fpos);
                            }
                            PARAM->ID=MSG_ID;
                            PARAM->Value.LoadBuffer(0,0);
                            filemarker=1;
                        }
                    }
                } else {
                    received=recv(CLIENT_SOCKET,buffer+rec_count,size-rec_count,0);
                    rec_count+=received;
                }

                if ((size >= BIG_MESSAGE) && (notify_parent)) {
                    notify_parent((int)(((double)rec_count/size)*100),0,idle_call);
                }
            } while ((received>0) && (rec_count<size));

            if (out_content2) {
                delete[] out_content2;
                out_content2=0;
            }

            if ((size >= BIG_MESSAGE) && (notify_parent)) {
                notify_parent(101,0,idle_call);
                // done big message !
            }

	        if (received<=0) {
               if (buffer)
	                delete[] buffer;
               return 0;
            }
        }

        if (PostFile) {
            post_done();
        } else {
            char *out_content=0;

            if ((LOCAL_PRIVATE_KEY) && (!CConceptClient::is_http))  {
                out_content=new char[size*2];
                buffer[size]=0;
                decrypt_result = AES_decrypt(   buffer, size,
                                                    out_content, size,
                                                    LOCAL_PRIVATE_KEY, /*strlen(LOCAL_PRIVATE_KEY)*/16 );
                out_content[decrypt_result]=0;
                if (!decrypt_result) {
                    delete[] out_content;
                    out_content=0;
                } else
                    size=decrypt_result;
            }

            if (out_content)
                DeSerializeBuffer(out_content, size, &PARAM->Sender, &MSG_ID, &PARAM->Target, &PARAM->Value);
            else
                DeSerializeBuffer(buffer, size, &PARAM->Sender, &MSG_ID, &PARAM->Target, &PARAM->Value);
            PARAM->ID=MSG_ID;

            if (out_content)
                    delete[] out_content;

        }
        if (buffer)
	            delete[] buffer;

        return size;
}
//---------------------------------------------------------------------------
int have_messages(SOCKET CLIENT_SOCKET) {
    if (CConceptClient::is_http) {
        return HTTPHaveMessage(CConceptClient::HTTP_PendingLink);
    } else {
        struct timeval timeout;
        timeout.tv_sec = 0;
        timeout.tv_usec = 100000;
        fd_set socks;

        int sel_val;

        FD_ZERO(&socks);
        FD_SET(CLIENT_SOCKET,&socks);
        sel_val=select(FD_SETSIZE, &socks, 0, 0, &timeout);

        return (sel_val>0);
    }
}
//---------------------------------------------------------------------------
int wait_message(TParameters *PARAM, long MESSAGE_ID, SOCKET CLIENT_SOCKET, char *LOCAL_PRIVATE_KEY, PROGRESS_API notify_parent) {
	int res=0;
	do {
		res=get_message(PARAM, CLIENT_SOCKET, LOCAL_PRIVATE_KEY, notify_parent);
        if (res<=0)
            break;
		if ((PARAM) && (PARAM->ID==MESSAGE_ID))
			return res;
		else {
			TParameters *clone=new TParameters;
			clone->Sender=PARAM->Sender;
			clone->ID=PARAM->ID;
			clone->Target=PARAM->Target;
			clone->Value=PARAM->Value;
			clone->Owner=PARAM->Owner;

			BufferedMessages.Add(clone, DATA_MESSAGE);
		}
	} while (res>0);
	return res;
}
//---------------------------------------------------------------------------
